// All paths are calculated relative to root directory of local.js
process.chdir( __dirname );

var logger = require('./logger.js');

logger.info( "Staring directory : " + process.cwd() );

// external
var url = require('url');

// supported commands
var modules = { debug : require('./debug.js') };
// process url args
var programArgs = function() {

    if( process.argv.length < 3 ) {
       var message =  "Invalid Program Args: Expected -> cmd?<param1 key>=<param1 value>&<param2 key>=<param2 value>.." ;
       throw message;
    } else {
        logger.info(  "Args : " + process.argv[2] );
    }

    var urlParts = url.parse( process.argv[2], true );
    // format the args into a single object understood by the app
    var args = urlParts.query;
    return args;

} ();

var module = modules[ programArgs.module ];
if( module ) {
    module( programArgs );
} else {
    throw "Could not find module-> " + programArgs.module;
}





