# ti-util 

A TI helper/util library for node.js and Node-Webkit

This utility includes many functions that a developer may find useful

## Installation

```bash
npm install git@gitorious.design.ti.com:guicomposer-nw/guicomposer-nw/node-modules/ti-util.git
```

## Usage
The ti-util module .

``` js
  var tiutil = require('ti-util');

  if(tiutil.isString(myVariable))
  {
	...
  }
```

## List of functions
ti-util includes the following helper functions:

* getUserHome
* tiDirectoryHome 
* getArguments
* getEnv
* isNodeWebkitApp
* getNodeWebkitVersion
* getAppName
* getAppVersion
* getAppDataDirectory
* getLocalAppDataDirectory
* getUserTempDirectory
* getUserName
* getComputerName
* getOS
* isWindows
* isLinux
* isMac
* isString
* isFunction
* isNumber
* isBoolean
* isDefined
* isEmpty
* isUndefined
* isObject
* isDate
* isError
* isRegExp
* isArray
* isRealObject
* isJSON


## Functions Details

* __getUserHome__ : returns the user home directory
* __tiDirectoryHome__ : returns TI directory under the user Home directory
* __getArguments__ : returns the argumments of the command that started the application
* __getEnv__ : Returns an object containing all the environment variable and their values
* __isNodeWebkitApp__ : returns true if the running app is a Node-Webkit app
* __getNodeWebkitVersion__ : returns the version of nw
* __getAppName__ : returns the name of the application as defined in application.json of the running app.
* __getAppVersion__ : return the version of the application as defined in application.json of the running app.
* __getAppDataDirectory__ : returns the APPData directory
* __getLocalAppDataDirectory__ : returns the local APPData directory
* __getUserTempDirectory__ : returns the user temporary directory
* __getUserName__ : returns the username
* __getComputerName__ : returns the computer name
* __getOS__ : returns a string with the os name
* __isWindows__ : returns true if the os is windows
* __isLinux__ : returns true if the os is linus
* __isMac__ : returns true if the os is Mac
* __isString__ : returns true if the argument is a String
* __isFunction__ : returns true if the argument is a function
* __isNumber__ : returns true if the argument is a number
* __isBoolean__ : returns true if the argument is a Boolean
* __isDefined__ : returns true if the argument not set to undefined
* __isEmpty__ : returns true if the argument is not empty
* __isUndefined__ : returns true if the argument is set to undefined
* __isObject__ : returns true if the argument is an Object
* __isDate__ : returns true if the argument is a Date
* __isError__ : returns true if the argument is an Error
* __isRegExp__ : returns true if the argument is a RegExp
* __isArray__ : returns true if the argument is an Array
* __isRealObject__ : returns true if the argument is a Real Object. This mean an Object that is not a String or a function, or a boolean, etc
* __isJSON__ : returns true if the argument is a valid JSON String




